/* actual TIFFS on-media structure */
struct inode_flash {
	u16	len;
	u8	reserved1;
	u8	type;
	u16	descend;
	u16	sibling;
	u32	dataptr;
	u16	sequence;
	u16	updates;
};

struct journal_entry {
	u8	status;
	u8	objtype;
	u16	this_ino;
	u16	link_ptr;
	u16	replacee;
	u32	location;
	u16	size;
	u16	repli;	/* ??? */
};

/* our own distilled info struct */
struct inode_info {
	int	ino;
	/* info from the inode record */
	int	type;
	int	descend;
	int	sibling;
	u16	len;
	u32	rawloc;
	u32	offset;
	u8	*dataptr;
	/* filled by treewalk */
	int	nparents;
	int	parent;
	/* filled by misc */
	u8	*byte_after_name;
};

/* chunk location and size info */
struct chunkinfo {
	u8	*start;
	u8	*end;
	size_t	len;
};
