#!/bin/sh
# A functional installation of FreeCalypso loadtools consists of not only
# the fc-* host binaries, but also the loadagent and compalstage target
# binaries and some script and help files.  This shell script is
# responsible for installing the latter.

instdir=/usr/local/share/freecalypso
set -ex
mkdir -p $instdir

# The target-binaries directory may or may not be present.  Loadagent and
# compalstage are built in the target-utils tree with the ARM7 toolchain,
# hence having prebuilt binaries would be an important convenience for
# end user releases.  But if one is working with just a source tree, with
# nothing prebuilt, there will be no target-binaries directory here;
# one needs to have the ARM7 toolchain installed, then build target-utils,
# then do a 'make install' there.

if [ -d target-binaries ]
then
	install -c target-binaries/* $instdir
fi

# scripts and loadtool.help should always be present
install -c scripts/* loadtool.help $instdir
