/******************************************************************************
 * FFS2 Protocol Indentifiers
 ******************************************************************************/

enum FFS2_PROTOCOL_IDENTIFIERS {
	TMFFS_FORMAT     = 'f',
	TMFFS_PREFORMAT  = 'p',

	TMFFS_MKDIR      = 'm',
	TMFFS_OPENDIR    = 'o',
	TMFFS_READDIR    = 'D',
	TMFFS_REMOVE     = 'd',
	TMFFS_RENAME     = 'n',
	TMFFS_XLSTAT     = 'x',

	TMFFS_SYMLINK    = 'y',
	TMFFS_READLINK   = 'Y',

	TMFFS_OPEN       = 'O',
	TMFFS_CLOSE      = 'C',
	TMFFS_READ       = 'R',
	TMFFS_WRITE      = 'W',
	TMFFS_SEEK       = 'S',

	TMFFS_FTRUNCATE  = 'T',
	TMFFS_TRUNCATE   = 't',

	TMFFS_FILE_READ  = 'r',
	TMFFS_FILE_WRITE = 'w',

	TMFFS_FSTAT      = 'F',
	TMFFS_LSTAT      = 'l',
	TMFFS_STAT       = 's',

	TMFFS_FCONTROL   = 'c',
	TMFFS_QUERY      = 'q',

	TMFFS_INIT       = 'i',
	TMFFS_EXIT       = 'e', 

	// Special
	TMFFS_DIRXLSTAT  = 'X',

	TMFFS_VERSION    = 'v',
	TMFFS_TFFS       = 'z'
}; 

#define TMFFS_STRING_SIZE	127	/* includes the terminating NUL */
#define	MAX_READ_DATA		254
