/*
 * This module implements the output/logging function
 */

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

extern int no_output;
extern FILE *logF;
extern time_t logtime;

static struct tm last_tm;

void
output_line(item)
	char *item;
{
	struct tm *curtm;

	if (!no_output)
		printf("%s\n", item);
	if (!logF)
		return;
	curtm = gmtime(&logtime);
	if (curtm->tm_year != last_tm.tm_year ||
	    curtm->tm_mon != last_tm.tm_mon ||
	    curtm->tm_mday != last_tm.tm_mday)
		fprintf(logF, "%d-%02d-%02d (gmtime):\n", curtm->tm_year + 1900,
			curtm->tm_mon+1, curtm->tm_mday);
	fprintf(logF, "[%02d:%02d:%02d] %s\n", curtm->tm_hour, curtm->tm_min,
		curtm->tm_sec, item);
	bcopy(curtm, &last_tm, sizeof(struct tm));
}
