/*
 * For sizing our buffers etc in rvinterf, we need a limit on the size of
 * message packets we can send to the target.  As it happens, the packet
 * Rx code in RVT on the target side also has a limit (quite naturally,
 * as it needs to use a static buffer to reassemble incoming packets as
 * they arrive at the UART in unpredictable interrupt-sized chunks), so
 * we set our limit to match that in RVT.
 */

#define	MAX_PKT_TO_TARGET	255

/*
 * The above limit definition counts all bytes between the opening and
 * closing STX flags, but not DLEs inserted for binary transparency.
 */
