/*
 * Flash blank check command
 */

#include <sys/types.h>
#include "types.h"

void
cmd_blankchk(argbulk)
	char *argbulk;
{
	char *argv[3];
	u_long start, length;
	u_long addr;
	int c;

	if (parse_args(argbulk, 2, 2, argv, 0) < 0)
		return;
	if (parse_hexarg(argv[0], 8, &start) < 0) {
		printf("ERROR: arg1 must be a valid 32-bit hex address\n");
		return;
	}
	if (parse_hexarg(argv[1], 8, &length) < 0) {
	    printf("ERROR: arg2 must be a valid 32-bit hex value (length)\n");
		return;
	}
	for (addr = start; addr < start + length; addr++) {
		c = *(volatile u8 *)addr;
		if (c != 0xFF) {
			printf("Not blank: %02X at %08X\n", c, addr);
			return;
		}
	}
	printf("OK\n");
}
