#include "cmdtab.h"

extern void cmd_AMFB();
extern void cmd_AMFW();
extern void cmd_INFB();
extern void cmd_INFW();
extern void cmd_abbr();
extern void cmd_abbw();
extern void cmd_blankchk();
extern void cmd_crc32();
extern void cmd_jump();
extern void cmd_r8();
extern void cmd_r16();
extern void cmd_r32();
extern void cmd_w8();
extern void cmd_w16();
extern void cmd_w32();

extern void cmd_baud_switch();
extern void cmd_intel_rewrite_sector();
extern void cmd_memdump_human();
extern void cmd_memdump_machine();
extern void cmd_memload();

extern void abb_init();
extern void abb_power_off();

const struct cmdtab cmdtab[] = {
	{"AMFB", cmd_AMFB},
	{"AMFW", cmd_AMFW},
	{"DUMP", cmd_memdump_machine},
	{"INFB", cmd_INFB},
	{"INFW", cmd_INFW},
	{"ML", cmd_memload},
	{"abbinit", abb_init},
	{"abbr", cmd_abbr},
	{"abbw", cmd_abbw},
	{"baud", cmd_baud_switch},
	{"blankchk", cmd_blankchk},
	{"crc32", cmd_crc32},
	{"dump", cmd_memdump_human},
	{"intel-rewrite-sector", cmd_intel_rewrite_sector},
	{"jump", cmd_jump},
	{"poweroff", abb_power_off},
	{"r8", cmd_r8},
	{"r16", cmd_r16},
	{"r32", cmd_r32},
	{"w8", cmd_w8},
	{"w16", cmd_w16},
	{"w32", cmd_w32},
	{0, 0}
};
